<?php
    function BuildTable($value) {
        $tableCell = array();
        if(isset($value) && !empty($value)) {
            $tableCell = preg_split("/::celldivide::/", html_entity_decode($value, ENT_QUOTES));
            foreach ($tableCell as $i => $cell) {
                $tableCell[$i] = json_decode($cell, true);
            }
        }

        // Set output markup
        $html = "";

        /* The Table Editor */
        $html .= "<table class='pmRateTable' id='pmRateTable'><tr>";
        $lastRow = -1;
        $lastCol = -1;

        if(!isset($tableCell) || (isset($tableCell) && count($tableCell) == 0)) {
            $html .= "<td data-colid='1234' data-rowid='2342'>";
            $html .= "<input type='text' value='Header 1' />";
            $html .= "</td><td data-colid='8766' data-rowid='2342'>";
            $html .= "<input type='text' value='Header 2' />";
            $html .= "</td><td class='pmRateTable-controls'><button class='pmRateTable-delete-row' type='button'>&times;</button><button class='pmRateTable-move-up' type='button'>&uarr;</button><button class='pmRateTable-move-down' type='button'>&darr;</button></td></tr>" .
            "<tr><td data-colid='1234' data-rowid='5435'>";
            $html .= "<input type='text' value='Data 1' />";
            $html .= "</td><td data-colid='8766' data-rowid='5435'>";
            $html .= "<input type='text' value='Data 2' />";
            $html .= "</td>";
            $html .= "<td class='pmRateTable-controls'><button class='pmRateTable-delete-row' type='button'>&times;</button><button class='pmRateTable-move-up' type='button'>&uarr;</button><button class='pmRateTable-move-down' type='button'>&darr;</button></td></tr><tr>" .
            "<td><button class='pmRateTable-delete-col' type='button'>&times;</button><button class='pmRateTable-move-left' type='button'>&larr;</button><button class='pmRateTable-move-right' type='button'>&rarr;</button></td><td><button class='pmRateTable-delete-col' type='button'>&times;</button><button class='pmRateTable-move-left' type='button'>&larr;</button><button class='pmRateTable-move-right' type='button'>&rarr;</button></td><td></td>" .
            "</tr></table>
                    <div class='pmrates-table-controls'>
                    <button id='pw-rateRow-add' onclick='pmAddRow(); return false;' type='button'>Add Row</button>
                    <button id='pw-rateCol-add' onclick='pmAddCol(); return false;' type='button'>Add Column</button>
                    <button id='pw-edit-cell' onclick='pmEditCell(); return false;' type='button'>Custom Edit Cell</button>
                </div>
                <div class='pmRateTable-short-code'><p>Selected Cell Short Code: <span class='js-pmRateTable-sc'></span></p></div>";
        } else {
            foreach ($tableCell as $cell)
            {
                if(is_null($cell)) continue;
                //Only iterate if the row or cell changed
                if ($lastRow != $cell["RowNumeric"] || $lastCol != $cell["ColNumeric"]) {
                    if ($lastRow != $cell["RowNumeric"]) {
                        if ($lastRow != -1) {
                            $html .= "<td class='pmRateTable-controls'><button class='pmRateTable-delete-row' type='button'>&times;</button><button class='pmRateTable-move-up' type='button'>&uarr;</button><button class='pmRateTable-move-down' type='button'>&darr;</button></td></tr><tr>";
                        }
                        $lastRow = $cell["RowNumeric"];
                    }
                    $html .= "<td class='has-preview' data-colid='" . $cell["ColID"] . "' data-rowid='" . $cell["RowID"] . "'>";
                    foreach ($tableCell as $innerCell) {
                        if(is_null($innerCell)) continue;
                        if ($innerCell["ColID"] == $cell["ColID"] && $innerCell["RowID"] == $cell["RowID"]) {
                            $cellvalue = html_entity_decode($innerCell["CellValue"], ENT_QUOTES);
                            if(is_null($cellvalue)) $cellvalue = '';
                            $preview_id = 'row'.$cell["RowID"].'col'.$cell["ColID"];
                            $html .= "<input oninput='refreshPreview(\"".$preview_id."\")' data-preview='".$preview_id."' id='".$preview_id."text' type='text' value='" . str_replace("::quote::", "&quot;", $cellvalue). "' />";
                            $html .= '<div class="cellpreview" tabindex="0" onclick="cellFocus(\''.$preview_id.'text\');"><div class="cellpreview-inner" id="'.$preview_id.'prev">'.str_replace("::quote::", '"', $cellvalue).'</div><button class="pw-edit-cell" onclick="pmEditCell(); return false;" type="button">Custom Edit Cell</button></div>';
                        }
                    }
                    $html .= "</td>";
                }
                $lastRow = $cell["RowNumeric"];
                $lastCol = $cell["ColNumeric"];
            }
            $html .= "<td class='pmRateTable-controls'><button class='pmRateTable-delete-row' type='button'>&times;</button><button class='pmRateTable-move-up' type='button'>&uarr;</button><button class='pmRateTable-move-down' type='button'>&darr;</button></td></tr><tr>";
            foreach ($tableCell as $cell) {
                if(is_null($cell)) continue;
                if ($lastRow == $cell["RowNumeric"]) {
                    if ($cell["ColNumeric"] != $lastCol) {
                        $html .= "<td><button class='pmRateTable-delete-col' type='button'>&times;</button><button class='pmRateTable-move-left' type='button'>&larr;</button><button class='pmRateTable-move-right' type='button'>&rarr;</button></td>";
                        $lastCol = $cell["ColNumeric"];
                    }
                }
            }
            $html .= "</tr></table>
                <div class='pmrates-table-controls'>
                    <button id='pw-rateRow-add' onclick='pmAddRow(); return false;' type='button'>Add Row</button>
                    <button id='pw-rateCol-add' onclick='pmAddCol(); return false;' type='button'>Add Column</button>
                    <button id='pw-edit-cell' onclick='pmEditCell(); return false;' type='button'>Custom Edit Cell</button>
                </div>
                <div class='pmRateTable-short-code'><p>Selected Cell Short Code: <span class='js-pmRateTable-sc'></span></p></div>";
        }
        echo $html;
    }
?>
